﻿using JPK_VDEK.Core;
using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace JPK_VDEK
{
    /// <summary>
    /// Logika interakcji dla klasy Ogolne.xaml
    /// </summary>
    public partial class Ogolne : UserControl
    {
        public MainWindow win { get; set; }
        public Ogolne()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Multiselect = false;
            openFileDialog.Title = "Podaj plik do przetworzenia IB";
            openFileDialog.Filter = "XML|*.xml";
            if (openFileDialog.ShowDialog() == true )
            {
                tigl.Text = openFileDialog.FileName;
            }

        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Multiselect = false;
            openFileDialog.Title = "Podaj plik do przetworzenia GL";
            openFileDialog.Filter = "CSV|*.csv";
            if (openFileDialog.ShowDialog() == true)
            {
                tgl.Text = openFileDialog.FileName;
            }
        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Multiselect = false;
            openFileDialog.Title = "Podaj plik do przetworzenia IB";
            openFileDialog.Filter = "XML|*.xml";
            if (openFileDialog.ShowDialog() == true)
            {
                tscal.Text = openFileDialog.FileName;
            }
        }

        private void Button_Click_3(object sender, RoutedEventArgs e)
        {
           
        }

        private void Button_Click_4(object sender, RoutedEventArgs e)
        {

        }

        private void Button_Click_5(object sender, RoutedEventArgs e)
        {

        }

        private void Button_Click_6(object sender, RoutedEventArgs e)
        {

        }

        private void bgen_Click(object sender, RoutedEventArgs e)
        {
            // wczytywanie pliku csv i wypełnianie struktur 
            string path = tgl.Text;
            string[] atr;
            if(tgl.Text.Length == 0)
            {
                return;
            }
            try
            {
                using (StreamReader sr = new StreamReader(path))
                {
                    string line = sr.ReadLine();
                    atr = line.Split('|');

                    JpkData.getJpk().Naglowek.KodUrzedu = TKodUS.Item0271;
                    JpkData.getJpk().UsNazwa = "DOLNOŚLĄSKI URZĄD SKARBOWY WE WROCŁAWJU";

                    JpkData.getJpk().Naglowek.Rok = atr[1].Substring(0, 4);
                    JpkData.getJpk().Naglowek.Miesiac = Convert.ToSByte(atr[1].Substring(4, 2));
                    JpkData.getJpk().Naglowek.DataWytworzeniaJPK = new DateTime(Convert.ToInt16(atr[3].Substring(0, 4)), Convert.ToInt16(atr[3].Substring(4, 2)), Convert.ToInt16(atr[3].Substring(6, 2)));
                    JpkData.getJpk().Naglowek.CelZlozenia.Value = 1;

                    TPodmiotDowolnyBezAdresuOsobaNiefizyczna fir = new TPodmiotDowolnyBezAdresuOsobaNiefizyczna();
                    JG jgos = new JG();
                    SpName sp = (SpName)jgos.Lista.FirstOrDefault(s => s.Kod == atr[0]);
                    fir.NIP = sp.NIP;
                    fir.PelnaNazwa = sp.Describe;
                    fir.Telefon = sp.telefon;
                    fir.Email = sp.email;
                    JpkData.getJpk().Podmiot1.Item = fir;

                   
                    while (!sr.EndOfStream)
                    {
                        line = sr.ReadLine();
                        atr = line.Split('|');
                        if (atr[1].Equals("D"))
                        {
                            JpkData.getJpk().Deklaracja.PozycjeSzczegolowe = new PozycjeSzczegolowe();
                            PozycjeSzczegolowe d1 = JpkData.getJpk().Deklaracja.PozycjeSzczegolowe;
                            d1.P_10 = atr[2] ;
                            d1.P_11 = atr[3];
                            d1.P_12 = atr[4];
                            d1.P_13 = atr[5];
                            d1.P_14 = atr[6];
                            d1.P_15 = atr[7];
                            d1.P_16 = atr[8];
                            d1.P_17 = atr[9];
                            d1.P_18 = atr[10];
                            d1.P_19 = atr[11];
                            d1.P_20 = atr[12];
                            d1.P_21 = atr[13];
                            d1.P_22 = atr[14];
                            d1.P_23 = atr[15];
                            d1.P_24 = atr[16];
                            d1.P_25 = atr[17];
                            d1.P_26 = atr[18];
                            d1.P_27 = atr[19];
                            d1.P_28 = atr[20];
                            d1.P_29 = atr[21];
                            d1.P_30 = atr[22];
                            d1.P_31 = atr[23];
                            d1.P_32 = atr[24];
                            d1.P_33 = atr[25];
                            d1.P_34 = atr[26];
                            d1.P_35 = atr[27];
                            d1.P_36 = atr[28];
                            d1.P_37 = atr[29];
                            d1.P_38 = atr[30];
                            d1.P_39 = atr[31];
                            d1.P_40 = atr[32];
                            d1.P_41 = atr[33];
                            d1.P_42 = atr[34];
                            d1.P_43 = atr[35];
                            d1.P_44 = atr[36];
                            d1.P_45 = atr[37];
                            d1.P_46 = atr[38];
                            d1.P_47 = atr[39];
                            d1.P_48 = atr[40];
                            d1.P_49 = atr[41];
                            d1.P_50 = atr[42];
                            d1.P_51 = atr[43];
                            d1.P_52 = atr[44];
                            d1.P_53 = atr[45];
                            d1.P_54 = atr[46];
                            if(atr[47].Equals("X"))
                            {
                                d1.ItemElementName = ItemChoiceType.P_55;
                                d1.Item = 1;
                                JpkData.getJpk().P55 = true;
                            }
                            if (atr[48].Equals("X"))
                            {
                                d1.ItemElementName = ItemChoiceType.P_56;
                                d1.Item = 1;
                                JpkData.getJpk().P56 = true;
                            }
                            if (atr[49].Equals("X"))
                            {
                                d1.ItemElementName = ItemChoiceType.P_57;
                                d1.Item = 1;
                                JpkData.getJpk().P57 = true;
                            }
                            if (atr[50].Equals("X"))
                            {
                                d1.ItemElementName = ItemChoiceType.P_58;
                                d1.Item = 1;
                                JpkData.getJpk().P58 = true;
                            }
                            if(atr[51].Equals("X"))
                            {
                                d1.P_59 = 1;
                                JpkData.getJpk().P59 = true;
                            }
                            else
                            {
                                d1.P_59 = 0;
                                JpkData.getJpk().P59 = false;
                            }
                            d1.P_60 = atr[52];
                            d1.P_61 = atr[53];
                            d1.P_62 = atr[54];
                            if (atr[55].Equals("X"))
                            {
                                d1.P_63 = 1;
                                JpkData.getJpk().P63 = true;
                            }
                            else
                            {
                                d1.P_63 = 0;
                                JpkData.getJpk().P63 = false;
                            }
                            if (atr[56].Equals("X"))
                            {
                                d1.P_64 = 1;
                                JpkData.getJpk().P64 = true;
                            }
                            else
                            {
                                d1.P_64 = 0;
                                JpkData.getJpk().P64 = false;
                            }
                            if (atr[57].Equals("X"))
                            {
                                d1.P_65 = 1;
                                JpkData.getJpk().P65 = true;
                            }
                            else
                            {
                                d1.P_65 = 0;
                                JpkData.getJpk().P65 = false;
                            }
                            if (atr[58].Equals("X"))
                            {
                                d1.P_66 = 1;
                                JpkData.getJpk().P66 = true;
                            }
                            else
                            {
                                d1.P_66 = 0;
                                JpkData.getJpk().P66 = false;
                            }
                            if (atr[59].Equals("X"))
                            {
                                d1.P_67 = 1;
                                JpkData.getJpk().P67 = true;
                            }
                            else
                            {
                                d1.P_67 = 0;
                                JpkData.getJpk().P67 = false;
                            }
                            d1.P_68 = atr[60];
                            d1.P_69 = atr[61];
                            d1.P_ORDZU = atr[62];
                            JpkData.getJpk().Deklaracja.Pouczenia = Convert.ToDecimal(atr[63].Replace('.', ',')); 
                        }
                        if (atr[1].Equals("S"))
                        {
                            JPKSprzedazWiersz spw = new JPKSprzedazWiersz();
                            spw.LpSprzedazy = atr[0];
                            JpkData.getJpk().SprzedazWiersz.Add(spw);
                            JpkData.getJpk().ViewSP.Add(spw);
                        }
                        if (atr[1].Equals("Z"))
                        {
                        }
                    }
                }
                win.DataContext = JpkData.getJpk();
            }
            catch (FileNotFoundException ex)
            {
 
            }
        }
    }
}
