﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace JPK_VDEK
{
    public static class JpkData
    {
        static private JpkExt aJpk;

        public static JpkExt getJpk()
        {
            if(aJpk==null)
            {
                aJpk = new JpkExt();
                aJpk.Naglowek = new JPKNaglowek();
                aJpk.Naglowek.KodFormularza = new TNaglowekKodFormularza();
                aJpk.Naglowek.CelZlozenia = new TNaglowekCelZlozenia();
                aJpk.Naglowek.KodFormularzaDekl = new TNaglowekKodFormularzaDekl();
                aJpk.Naglowek.WariantFormularzaDekl = 21;
                aJpk.Naglowek.WariantFormularza = 1;

                aJpk.Podmiot1 = new JPKPodmiot1();

                aJpk.Deklaracja = new JPKDeklaracja();

                aJpk.SprzedazWiersz = new List<JPKSprzedazWiersz>();

                aJpk.SprzedazCtrl = new JPKSprzedazCtrl();

                aJpk.ZakupWiersz = new List<JPKZakupWiersz>();

                aJpk.ZakupCtrl = new JPKZakupCtrl();
                aJpk.ViewSP = new ObservableCollection<JPKSprzedazWiersz>();
            }
            return aJpk;
        }
    }

    public class JpkExt : JPK
    {
        public ObservableCollection<JPKSprzedazWiersz> ViewSP { get; set; }
        public string  UsNazwa { get; set; }
        public bool P55 { get; set; }
        public bool P56 { get; set; }
        public bool P57 { get; set; }
        public bool P58 { get; set; }
        public bool P59 { get; set; }
        public bool P63 { get; set; }
        public bool P64 { get; set; }
        public bool P65 { get; set; }
        public bool P66 { get; set; }
        public bool P67 { get; set; }

    }
}
